/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.InterpolationToRegularField;

import java.awt.BorderLayout;
import java.util.Hashtable;
import javax.swing.JLabel;
import javax.swing.UIManager;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.filters.InterpolationToRegularField.InterpolationToRegularFieldShared.*;
import org.visnow.vn.system.swing.UIManagerKey;

public class GUI extends javax.swing.JPanel
{
    private final String[] densities = {"<html>very<p>coarse</html>", "coarse", "std", "fine", "<html>very<p>fine</html>", "<html>super<p>fine</html>"};
    private Parameters parameters;
    private int nSpace = 3;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
        Hashtable labelTable = new Hashtable();
        for (int i = 0; i < densities.length; i++) 
            labelTable.put( new Integer(10 * i), new JLabel(densities[i]) );
        globalResSlider.setLabelTable(labelTable);
        resPanel.setVisible(false);
        globalResSlider.setVisible(true);
        glyphGUIPanel.setVisible(false);
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        nSpace = p.get(META_TRUE_NSPACE);
        resSlider2.setEnabled(nSpace > 2);
        if (nSpace > 2) {
            resSlider0.setVal(p.get(RESOLUTION0));
            resSlider1.setVal(p.get(RESOLUTION1));
            resSlider2.setVal(p.get(RESOLUTION2));
        }
        else {
            resSlider1.setVal(p.get(RESOLUTION0));
            resSlider0.setVal(p.get(RESOLUTION1));
        }
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel4 = new javax.swing.JPanel();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        glyphGUIPanel = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        autoButton = new javax.swing.JRadioButton();
        manualButton = new javax.swing.JRadioButton();
        resPanel = new javax.swing.JPanel();
        resSlider0 = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        resSlider1 = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        resSlider2 = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        dimsButton = new javax.swing.JRadioButton();
        densityButton = new javax.swing.JRadioButton();
        globalResSlider = new javax.swing.JSlider();

        setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel4, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton, gridBagConstraints);

        glyphGUIPanel.setMinimumSize(new java.awt.Dimension(200, 390));
        glyphGUIPanel.setPreferredSize(new java.awt.Dimension(220, 450));
        glyphGUIPanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(glyphGUIPanel, gridBagConstraints);

        jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel5.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("<html>box orientation<p>and position</html>");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.4;
        gridBagConstraints.insets = new java.awt.Insets(6, 15, 6, 0);
        jPanel5.add(jLabel1, gridBagConstraints);

        buttonGroup2.add(autoButton);
        autoButton.setSelected(true);
        autoButton.setText("auto");
        autoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                autoButtonActionPerformed(evt);
            }
        });
        jPanel5.add(autoButton, new java.awt.GridBagConstraints());

        buttonGroup2.add(manualButton);
        manualButton.setText("manual");
        manualButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                manualButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 3);
        jPanel5.add(manualButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanel5, gridBagConstraints);

        resPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        resPanel.setMinimumSize(new java.awt.Dimension(134, 206));
        resPanel.setPreferredSize(new java.awt.Dimension(210, 220));
        resPanel.setLayout(new java.awt.GridLayout(3, 0));

        resSlider0.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "i dimension", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, (java.awt.Font)UIManager.get(UIManagerKey.TitledBorder_font.getKey()), new java.awt.Color(153, 0, 153)));
        resSlider0.setMax(500);
        resSlider0.setMin(50);
        resSlider0.setName(""); // NOI18N
        resSlider0.setVal(100);
        resSlider0.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                resSlider0StateChanged(evt);
            }
        });
        resPanel.add(resSlider0);

        resSlider1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "j dimension", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, (java.awt.Font)UIManager.get(UIManagerKey.TitledBorder_font.getKey()), new java.awt.Color(153, 153, 0)));
        resSlider1.setMax(500);
        resSlider1.setMin(50);
        resSlider1.setName(""); // NOI18N
        resSlider1.setVal(100);
        resSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                resSlider1StateChanged(evt);
            }
        });
        resPanel.add(resSlider1);

        resSlider2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "k dimension", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, (java.awt.Font)UIManager.get(UIManagerKey.TitledBorder_font.getKey()), new java.awt.Color(0, 153, 153)));
        resSlider2.setMax(500);
        resSlider2.setMin(50);
        resSlider2.setName(""); // NOI18N
        resSlider2.setVal(100);
        resSlider2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                resSlider2StateChanged(evt);
            }
        });
        resPanel.add(resSlider2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(resPanel, gridBagConstraints);

        buttonGroup1.add(dimsButton);
        dimsButton.setText("set i/j/k dimensions"); // NOI18N
        dimsButton.setMaximumSize(new java.awt.Dimension(140, 30));
        dimsButton.setMinimumSize(new java.awt.Dimension(140, 2));
        dimsButton.setPreferredSize(new java.awt.Dimension(140, 25));
        dimsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dimsButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(dimsButton, gridBagConstraints);

        buttonGroup1.add(densityButton);
        densityButton.setSelected(true);
        densityButton.setText("set global resolution"); // NOI18N
        densityButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                densityButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(densityButton, gridBagConstraints);

        globalResSlider.setMajorTickSpacing(10);
        globalResSlider.setMaximum(50);
        globalResSlider.setMinorTickSpacing(2);
        globalResSlider.setPaintLabels(true);
        globalResSlider.setPaintTicks(true);
        globalResSlider.setValue(20);
        globalResSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                globalResSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(globalResSlider, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void resSlider0StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_resSlider0StateChanged
        if (!resSlider0.isAdjusting()) 
            parameters.set(nSpace > 2 ? RESOLUTION0 : RESOLUTION1, resSlider0.getVal());
    }//GEN-LAST:event_resSlider0StateChanged

    private void resSlider1StateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_resSlider1StateChanged
    {//GEN-HEADEREND:event_resSlider1StateChanged
        if (!resSlider1.isAdjusting()) 
            parameters.set(nSpace > 2 ? RESOLUTION1 : RESOLUTION0, resSlider1.getVal());
    }//GEN-LAST:event_resSlider1StateChanged

    private void resSlider2StateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_resSlider2StateChanged
    {//GEN-HEADEREND:event_resSlider2StateChanged
        if (!resSlider2.isAdjusting()) 
            parameters.set(nSpace > 2 ? RESOLUTION2 : RESOLUTION2, resSlider2.getVal());
    }//GEN-LAST:event_resSlider2StateChanged

    private void dimsButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_dimsButtonActionPerformed
    {//GEN-HEADEREND:event_dimsButtonActionPerformed
        updateGlobalResolution();
    }//GEN-LAST:event_dimsButtonActionPerformed

    private void densityButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_densityButtonActionPerformed
    {//GEN-HEADEREND:event_densityButtonActionPerformed
        updateGlobalResolution();
    }//GEN-LAST:event_densityButtonActionPerformed

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void autoButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_autoButtonActionPerformed
    {//GEN-HEADEREND:event_autoButtonActionPerformed
        parameters.set(AUTO, autoButton.isSelected());
        glyphGUIPanel.setVisible(manualButton.isSelected());
    }//GEN-LAST:event_autoButtonActionPerformed

    private void manualButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_manualButtonActionPerformed
    {//GEN-HEADEREND:event_manualButtonActionPerformed
        parameters.set(AUTO, autoButton.isSelected());
        glyphGUIPanel.setVisible(manualButton.isSelected());
    }//GEN-LAST:event_manualButtonActionPerformed

    private void globalResSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_globalResSliderStateChanged
        int res = (int)(64 * Math.pow(2, globalResSlider.getValue() / 10.));
        parameters.set(RESOLUTION, res);
    }//GEN-LAST:event_globalResSliderStateChanged

    private void updateGlobalResolution()
    {
        resPanel.setVisible(dimsButton.isSelected());
        globalResSlider.setVisible(densityButton.isSelected());
        parameters.set(GLOBAL_RESOLUTION, densityButton.isSelected());
    }
    
    public void addGlyphUI(javax.swing.JPanel glyphGUI)
    {
        glyphGUIPanel.add(glyphGUI, BorderLayout.CENTER);
    }
    
    public void resetAuto()
    {
        autoButton.setSelected(true);
        glyphGUIPanel.setVisible(false);
        densityButton.setSelected(true);
        resPanel.setVisible(false);
    }
    
    
    void armRunButton()
    {
        runButton.setPendingIfNoAuto();
    }
    
    void disarmRunButton()
    {
        runButton.clearPending();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton autoButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JRadioButton densityButton;
    private javax.swing.JRadioButton dimsButton;
    private javax.swing.JSlider globalResSlider;
    private javax.swing.JPanel glyphGUIPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JRadioButton manualButton;
    private javax.swing.JPanel resPanel;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider resSlider0;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider resSlider1;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider resSlider2;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    // End of variables declaration//GEN-END:variables


}
